<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <div class="update-peer-page">
        <p>
            <a href="/peers/{{ .Form.ID }}" class="button--link"
                >{{ svg "icon-chevron-left" "icon--inline" }}
                {{ i18n "Back" }}</a
            >
        </p>

        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-post="/peers/{{ .Form.ID }}/edit"
            hx-target="body"
            hx-swap="outerHTML"
            action="/peers/{{ .Form.ID }}/edit"
            method="post"
            autocomplete="off"
            class="update-peer-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />

            <fieldset class="update-peer-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Edit" }}
                </button>
            </fieldset>

            <fieldset>
                <label>
                    <span>{{ i18n "Name" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="name"
                        value="{{ .Form.Name }}"
                        oninvalid="nameOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>

                <label>
                    <span>{{ i18n "Manager Address" }}</span>
                    <input
                        class="input--large"
                        type="text"
                        name="managerAddress"
                        value="{{ .Form.ManagerAddress }}"
                        required
                        pattern="^https:\/\/\S+:8443$"
                        oninvalid="managerAddressOnInvalidHandler(this)"
                        oninput="this.setCustomValidity('')"
                    />
                </label>
            </fieldset>

            <script>
                function nameOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Name of the Peer is required" }}')
                    }
                }

                function managerAddressOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Manager Address of the Peer is required" }}')
                    } else if (el.validity.patternMismatch) {
                        el.setCustomValidity('{{ i18n "Manager address must be a valid URL including the scheme https and the port 8443." }}')
                    }
                }
            </script>
        </form>
    </div>
{{ end }}
